import subprocess as sub
from libtaskotron.directives import BaseDirective
from libtaskotron.logger import log
from libtaskotron.exceptions import TaskotronDirectiveError

directive_class = 'CreaterepoDirective'


class CreaterepoDirective(BaseDirective):
    def process(self, input_data, env_data):
        """For the createrepo directive, we're expecting a yaml declaration of
        the form "createrepo: repodir=/path/to/some/dir"
        """

        repodir = input_data['repodir']

        log.info('running createrepo on %s', repodir)

        p = sub.Popen(['createrepo', repodir], stdout=sub.PIPE, stderr=sub.PIPE)

        output, errors = p.communicate()

        if p.returncode:
            raise TaskotronDirectiveError(errors)

        log.debug(output)

        return output
