# -*- coding: utf-8 -*-
# Copyright 2010-2014, Red Hat, Inc.
# License: GNU General Public License version 2 or later

'''This module contains custom Taskotron exceptions'''


class TaskotronError(Exception):
    '''Common ancestor for Taskotron related exceptions'''
    pass


class TaskotronValueError(ValueError, TaskotronError):
    '''Taskotron-specific :class:`ValueError`'''
    pass


class TaskotronConfigError(TaskotronError):
    '''All errors related to Taskotron config files'''
    pass

class TaskotronYamlError(TaskotronError):
    '''Error in YAML config file of the executed check'''
    pass


class TaskotronDirectiveError(TaskotronError):
    '''All errors related to Taskotron directives'''
    pass


class TaskotronRemoteError(TaskotronError):
    '''All network and remote-server related errors'''
    pass
