# -*- coding: utf-8 -*-
# Copyright 2014, Red Hat, Inc.
# License: GNU General Public License version 2 or later

'''A collection of convenience methods related to Python base libraries.'''

import collections


def listlike(value):
    '''Return whether ``value`` is iterable (``list``, ``tuple``, ``set``,
    etc), but not ``str`` (which is iterable, but we don't often want to
    consider it as such). This method is useful e.g. if you want to check that a
    variable contains a list/set/etc of strings.

    :param any value: any object or literal you want to check
    :return: whether ``value`` is iterable but not string
    :rtype: bool
    '''
    return (isinstance(value, collections.Iterable) and
            not isinstance(value, basestring))
