# -*- coding: utf-8 -*-
# Copyright 2014, Red Hat, Inc.
# License: GNU General Public License version 2 or later

'''Unit tests for libtaskotron/python_utils.py'''

from libtaskotron import python_utils

class TestPythonUtils:

    def test_listlike_true(self):
        '''Test 'listlike' method when it returns True'''
        assert python_utils.listlike([1, 2])
        assert python_utils.listlike(['a', 'b'])
        assert python_utils.listlike(('foo',))
        assert python_utils.listlike({'foo', 'bar', 'baz'})
        assert python_utils.listlike(set())
        assert python_utils.listlike(())
        assert python_utils.listlike([u'foo', u'bar'])
        assert python_utils.listlike({'a': 1, 'b': 2})

    def test_listlike_false(self):
        '''Test 'listlike' method when it returns False'''
        assert not python_utils.listlike('a')
        assert not python_utils.listlike(u'a')
        assert not python_utils.listlike(unicode('foo'))
        assert not python_utils.listlike(3)
        assert not python_utils.listlike(3.14)
        assert not python_utils.listlike(None)
        assert not python_utils.listlike(object())
